; Bootsektor ObjectsOS 
; Copyright by ObjectsOS - Team 2001. All rights reserved.
; Datum: 5. Mrz 2001 18.24

bits 16
org 0x7C00

start: jmp short load
       nop




;Irgendwie ist dein Bootsektor inkompatibel mit FAT12 gewesen, da einige Teile
;aus FAT32 geklaut waren. Windows hatte damit belste Probleme. Ich habe ihn also
;etwas abgendert aber deine Begriffe grtenteils beibehalten.

oem       db "OOS0.1.1"               ; OEM
bps  dw 512                          ; Bytes/Sektor
spc db 1                            ; Sektoren/Cluster
rs   dw 1                            ; Reservierte Sektoren
noFats    db 2                            ; Anzahl der FAT Kopien
rde  dw 224                          ; Grsse des Root-Verzeichnisses
ls_s dw 2880                           ; Sektoranzahl wenn < 32MB
Media     db 0xF0                       ; Media-Descriptor(hier 1.44MB Diskette)
spF_s   dw 9                            ; Gre vom FAT
spt dw 18                           ; Sektoren pro Spur
hpt   dw 2                            ; Anzahl der Read/Write Kpfe
hs dd 0                                ; Versteckte Sektoren
ls_l  dd 0                            ; Sektorenanzahl wenn > 32MB
dn   db 0                            ; Laufwerk
reserved    db 0                        ; unbenutzt
Signatur  db 29h                        ; Boot-Signatur 29h
DiskID    dd 0                          ; Disk-Volume-UD
Name   db "NO NAME    "                 ; Name
Dateisystem    db "FAT12   "            ; Dateisystem


fehler: mov si, Fehler
        call printstring
error:    xor        ah, ah
    int        0x16                    ;Tastendruck abwarten

    db        0xEA                    ;hier erfolgt der Reboot
    dw        0x0000
    dw        0xFFFF

;ab hier beginnt der ausfhrbare Code
load:        cli                                 ; Schalte Interrupts lieber ab
            mov [dn],dl                    ; ...und speichere mir meine Laufwerksnummer
            mov ax,0x9000                      ; Und richte mir meinen Stack ein
            mov ss,ax
            mov sp,0x8000

            mov cx,[spt]                   ; Update die int 1E FDC param table
            mov bx,0x0078               
            lds si,[ds:bx]
            mov byte [si+4], cl
            mov byte [si+9], 0x0F

            sti                         ; Schalte Interrupts wieder ein
            push ds
            mov dl,[dn]                 ; ...und setze meinen Controller zurck
            xor ax,ax
            int 0x13
            pop ds
            jc bootfail2                ; Fehlermeldung anzeigen !
            jmp _l1
bootfail2:  jmp fehler
_l1:
            mov ax,0x0000        ; Segmentiere ein wenig...
            mov es,ax
            mov ds,ax

;           mov si,Ausgabe                   ; Unser toller Slogan
;           call printstring
; Habe die Ausgabe ersteinmal rausgenommen, da ich ja noch hoffe, dass
; es im Lader einen tollen bunten Bildschirm gibt

            ; Finde das Rootverzeichnis
        ; Das hier ist ziemlich logisch und einfach durch den FAT-Aufbau nachzuvollziehen
        ; vielleicht hat jemand mal lust das ordentlich zu dokumentieren. 
            xor ax,ax
            mov al,[noFats]
            mov bx,[spF_s]
            mul bx
            add ax,word [hs]
            adc ax,word [hs+2]
            add ax,word [rs]   
            mov word [BootSig],ax  ;Position des Hauptverzeichnisses wird in BootSig abgesp.

            call checkroot       ; Lade mir alle wichtigen Daten ber unseren Loader

            xor ax,ax
            add ax,word [start]
            add ax,word [DiskID]       ; Sektornummer
            add ax,word [BootSig]
            sub ax,2                    ; Fehlerausgleich fr falschberechnung unten (s.u.)
            mov cx,word [DiskID+2]     ; Sektoranzahl

            mov bx,0x400			;Adresse zum Laden -----+
            mov es,bx				;				|
							;				|
						;					|
nextsector: push ax                     ; Rette Register		|
            push cx			;					|
            push dx			;					|
            push es			;					|
;											|
            xor bx,bx                   ; Offset = 0   -----------+
            call lesesektor               ; Lese einen Sektor

            mov si,Punkt               ; Stelle einen Punkt dar (deakt.)
            call printstring

            pop es                      ; ... und hole mir meine register wieder
            pop dx
            pop cx
            pop ax
            mov bx,es
            add bx,20h                  ; Erhhe Adresse um 512 Bytes (stimmt immer bei Disketten)
            mov es,bx
            inc ax                      ; Lese nchsten Sektor
            loopnz nextsector

		mov		ax,	3
		int		0x10

		jmp		0x400:00

; Diese nette Funktion ldt alle Infos ber unseren Bootloader (Jippie)
checkroot:
            push ax                     ; Sichere mir vorsichtshalber alle Register
            push bx
            push cx
            push dx
            push si
            push di
            
            mov ax,0x400               ; Tue das Hauptverzeichnis nach 0x80000
            mov es,ax
                    ; Da eine Verzeichnisliste 32 Bit pro Eintrag 
                    ; enthlt, beechne ich die Grsse des HV ganz
                    ; einfach durch 32*Eintrge im HV. Um dann 
                    ; herauszubekommen, wieviele Sektoren das HV
                    ; umfasst, dividiere ich durch Bytes/Sektor
            mov ax,32                   ; AX = ((32*Eintrge)/512) + 2
            mul word [rde]
            div word [bps]
            mov cx,ax                   ; CX = Sektoranzahl in Root
            mov word [start],ax
            mov ax,word [BootSig]       ; In BootSig haben wir vorhin den Ort des HV abgelegt

r1:         xor bx,bx            ; Lese Sektor an 0x80000:00000
            push cx                     ; Sichere meinen Zhler
            push ax                     ; Sichere Sektornummer
            push es
            push dx
            call lesesektor               ; Lese einen Sektor
            xor bx,bx
l_1:        mov di,bx                   ; set address to check from
            mov cx,11                   ; Checke 11 Bytes (8 + 3 Endung)
            mov si,LaderName            ; Name des Laders in SI
            repz cmpsb            ; Vergleiche, ob der Dateiname identisch ist
            je foundit            ; wenn ja springe zu foundit
            add bx,32                   ; Wenn nein gehe zum nchsten 32bit Verzeichniseintrag
            cmp bx,[bps]             ; Habe ich das Ende des Sektors erreicht ???
            je l_2            ; Wenn ja gehe zu l2 (dort steht, dass der 
                    ; nchste Sektor gelesen wird
            jmp l_1
l_2:        pop dx                      ; Stelle Register wieder her
            pop es
            pop ax
            pop cx
            inc ax                      ; Lese nchsten Sektor
            loopnz r1            ; Gehe wieder zu r1
            jmp fehler                  ; Wenn nirgendwo ein Eintrag fr unseren Loader ist
                    ; dann hat jemand Pech gehabt
foundit:    pop dx                      ; Entferne Stackverunreinigung
            pop es
            pop ax
            pop cx

            mov di,0x1A                 ; Berechne die Clusternummer
                    ; Dies geschieht ganz einfach. Da nmlich 26 Bytes nach
                    ; dem Verzeichnisnahmen die Clusternummer im Verzeichnis-
                    ; eintrag steht (26 = 0x1a)
            add di,bx            ; Addiere Bytes hinzu, wo der Dateiname gefunden wurde
            push bx                     ; Sichere BX um die Sektorenanzahl zu finden
            mov ax,[es:di]        ; Clusternummer ist jetzt in ax
            xor bx,bx             ; BX = 0
            mov bl,[spc]        ; BX = Sektoren / Cluster
            mul bx                      ; Jetzt enthlt ax die Sektornummer
            mov word [DiskID],ax       ; Die wir uns gleich mal sichern

            pop bx                      ; Jetzt brauchen wir die Lnge der Datei
            mov di,0x1C            ; 28 Bytes oder 0x1c Bytes hinter dem Dateinamen steht
                    ; die Lnge der Datei in Bytes
            add di,bx            ; Fundort dazuaddieren, wie immer (*mdwerd*)
            mov ax,[es:di]              ; Anzahl der Bytes ist jetzt in AX
            xor dx,dx
            mov bx,[bps]
            div bx            ; Anzahl der zu ladenden Sektoren ist jetzt in AX
            inc ax            ; Erhhe ax, da bei der anzahl einer dazuaddiert werden
                    ; musss
            mov word [DiskID+2],ax     ; Das wird gespeichert

            pop di                      ; Stelle Register wieder her
            pop si
            pop dx
            pop cx
            pop bx
            pop ax
            
            ret                         ; Zurck

; Diese kleine Routine liest einen Sektor in ES:BX, AX Kennzeichnet den Sektor
lesesektor:  
            mov si,[spt]        ; SI = Sektoren pro Spur
            div si                      ; Dividiere den logischen Sektor durch Spur/Sektor
                    ; Jetzt habe ich die Spur die ich lesen soll in AX
                    ; und den Sektor in dieser Spur in DX
            inc dl                      ; Da der Sektor nicht bei 0 beginnt, sondern bei 1
                    ; wird dl erhht
            mov [reserved],dl           ; Speichere mir den zu lesenden Sektor ab
            xor dx,dx                   ; Lsche mir dx - logische Spur bleibt in AX zurck
            div word [hpt]              ; Division durch die Kpfe/Spur
                    ; Nach dieser Division stehen die Kpfe in dl und 
                    ; der Zylinder in ax
            mov dh, [dn]             ; Lade die Laufwerksnummer
            xchg dl,dh                  ; und tausche aus, damit alles fr die BIOS-FKT stimmt
            mov cx,ax                   ; Der Zylinder muss in CX
            xchg cl,ch                  ; Die unteren acht Bits von Zylinder mssen in CH
            shl cl,6                    ; die oberen 2 bits mssen auf bits 6-7 geshiftet werden
            or cl, byte [reserved]      ; or mit der sektornummer
            mov al,1                    ; Anzahl der zu lesenden Sektoren
            mov ah,2                    ; Bios-Funktion
            int 0x13                    ; Lese-Sektor
            jc bootfail3                ; Fehlermeldung ausgeben
            ret                         ; Ende
bootfail3:  jmp fehler

; Hier sind die paar Variablen, die wir brauchen
LaderName               db "LOADER  OOS"
Fehler              db "Diskettenfehler...",13,10,0
Punkt				db '.', 0

;------------------------------------------------------------------------------------------------------------------------------------------------------
printstring:

lodsb                                    ;si -> al
or    al, al                            ;al = 0? wenn ja dann done
jz    done
mov    ah, 0x0E
mov    bx, 7
int    0x10                                ;Interrupt auslsen
jmp    printstring                            ;zurckspringen

done:
ret
;--------------------------------------------------------------------------------------------------------------------------------------------------------

times 510 - ($-$$)      db 0x00
BootSig                 dw 0xAA55
