/*
This file is part of ObjetcsOS.

ObjetcsOS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

ObjetcsOS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ObjectsOS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "screen.h"
#include "system.h"
#include "data.h"
#include "floppy.h"

SYSTEM_INFO system;
extern void *sectorbuffer;

void init()
{
        writeln("::ObjectsOS::");
        writeln("Version 0.01a");
        writeln("");

        getGDTInfo();
        initIDT();
        initPIC();
        initFloppy();
        enableA20();

        system.mem = count_memory();
        write("Speicher: "); write(inttostr(system.mem << 20)); write(" Byte (");
        write(inttostr(system.mem)); writeln(" MByte)");
}

int main()
{
        init();
        return 0;
}
