/*
This file is part of ObjetcsOS.

ObjetcsOS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

ObjetcsOS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ObjectsOS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "screen.h"
#include "system.h"
#include "data.h"

SCREEN screen = {0, 0, 80, 25, 7};

void setCursor(char x, char y)
{
        WORD pos = y * screen.resx + x;
        outportb(0x3D4, 0x0F);
        outportb(0x3D5, (BYTE)(pos & 0xFF));
        outportb(0x3D4, 0x0E);
        outportb(0x3D5, (BYTE)((pos >> 8) & 0xFF));
}

void write(char* string)
{
        WORD pos;
        while(*string) {
                if(screen.y >= screen.resy) scrollscreen(); /*scrollen*/
                pos = (screen.y * screen.resx + screen.x) *2;
                movedata(SYS_DATA_SEL, (unsigned)string, SYS_SCREEN_SEL, pos, 1);
                movedata(SYS_DATA_SEL, (unsigned)&screen.color, SYS_SCREEN_SEL, pos+1, 1);
                string++;
                screen.x++;
                if(screen.x >= screen.resx) { /*neue Zeile*/
                        screen.x = 0;
                        screen.y++;
                }
        }
        if(screen.y >= screen.resy) scrollscreen(); /*scrollen*/
        setCursor(screen.x, screen.y);
}

void writeln(char *string)
{
        write(string);
        screen.y++;
        screen.x = 0;
        if(screen.y >= screen.resy) scrollscreen(); /*scrollen*/
        setCursor(screen.x, screen.y);
}

char getBGColor()
{
        return screen.color/16;
}

void putchar(BYTE x, BYTE y, BYTE c)
{
        WORD p = (y*screen.resx*2) + (2*x);
        if(x >= screen.resx) return;
        if(y >= screen.resy) return;
        movedata(SYS_DATA_SEL, (unsigned)&c, SYS_SCREEN_SEL, (unsigned)p, 1);
        movedata(SYS_DATA_SEL, (unsigned)&screen.color, SYS_SCREEN_SEL, (unsigned)p+1, 1);
}

void scrollscreen()
{
        BYTE i;
        movedata(SYS_SCREEN_SEL, (unsigned)screen.resx*4, SYS_SCREEN_SEL, screen.resx*2, (screen.resy-2) * screen.resx * 2);
        for(i = 0; i < screen.resx; i++) putchar(i, screen.resy-1, ' ');
        screen.y--;
        setCursor(screen.x, screen.y);
}

void simulTab()
{
        if(screen.x % TABWIDTH == 0) screen.x+=5;
        else while(screen.x % TABWIDTH != 0) screen.x++;
        setCursor(screen.x, screen.y);
}

void gotoXY(BYTE x, BYTE y)
{
        if(x >= screen.resx) return;
        if(y >= screen.resy) return;
        screen.x = x;
        screen.y = y;
        setCursor(screen.x, screen.y);
}
